/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.person.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.person.entity.PersonenVerknuepfung;
import de.ivu.elect.business.person.entity.PersonenVerknuepfungUK;

public abstract class AbstractPersonenVerknuepfungDAO extends de.ivu.elect.jee.entity.AbstractDAO<PersonenVerknuepfung,
        de.ivu.elect.business.person.entity.PersonenVerknuepfungPK
    , PersonenVerknuepfungUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractPersonenVerknuepfungDAO.class);

  public AbstractPersonenVerknuepfungDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.person.entity.PersonenVerknuepfungPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public PersonenVerknuepfung findByPrimaryKey(
        de.ivu.elect.business.person.entity.PersonenVerknuepfungPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected PersonenVerknuepfung findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(PersonenVerknuepfung.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: NurPerson1NoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM PersonenVerknuepfung obj WHERE obj.person1 = ?1<br>
      * SQL: <br>
      */
     public java.util.List<PersonenVerknuepfung> findByNurPerson1( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten person) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.person.entity.Personendaten personCheckedAndAttached =  checkAndAttach(person, de.ivu.elect.business.person.entity.Personendaten.class, "person"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_VERKNUEPFUNG.NurPerson1")
                              .setParameter(1, personCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByNurPerson1 - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenVerknuepfung, findByNurPerson1 - NonUniqueResultException, Parameter: "
           + ", person:'"+person+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByNurPerson1(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: PersonNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT obj FROM PersonenVerknuepfung obj WHERE obj.person1 = ?1 OR obj.person2 = ?1<br>
      * SQL: <br>
      */
     public java.util.List<PersonenVerknuepfung> findByPerson( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten person) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.person.entity.Personendaten personCheckedAndAttached =  checkAndAttach(person, de.ivu.elect.business.person.entity.Personendaten.class, "person"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_VERKNUEPFUNG.Person")
                              .setParameter(1, personCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByPerson - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenVerknuepfung, findByPerson - NonUniqueResultException, Parameter: "
           + ", person:'"+person+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByPerson(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: PersonenNoFlush<br>
      * Beschreibung: @Deprecated //<br>
      * EJBQL: SELECT obj FROM PersonenVerknuepfung obj WHERE (obj.person1 = ?1 AND obj.person2 = ?2) OR (obj.person2 = ?1 AND obj.person1 = ?2)<br>
      * SQL: <br>
      */
     public java.util.List<PersonenVerknuepfung> findByPersonen( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten person1,  @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten person2) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.person.entity.Personendaten person1CheckedAndAttached =  checkAndAttach(person1, de.ivu.elect.business.person.entity.Personendaten.class, "person1"); ;
		  			  de.ivu.elect.business.person.entity.Personendaten person2CheckedAndAttached =  checkAndAttach(person2, de.ivu.elect.business.person.entity.Personendaten.class, "person2"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_VERKNUEPFUNG.Personen")
                              .setParameter(1, person1CheckedAndAttached)
                                        .setParameter(2, person2CheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenVerknuepfung, findByPersonen - NonUniqueResultException, Parameter: "
           + ", person1:'"+person1+"'"
           + ", person2:'"+person2+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByPersonen(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndVerknuepfungsGrundlageAndVerknuepfungsStatusNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT pv FROM PersonenVerknuepfung pv WHERE pv.person1.wahl=?1 AND pv.verknuepfungsGrundlage=?2 AND pv.verknuepfungsStatus=?3<br>
      * SQL: <br>
      */
     public java.util.List<PersonenVerknuepfung> findByWahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.person.entity.VerknuepfungsGrundlage verknuepfungsGrundlage,  @javax.annotation.Nonnull de.ivu.elect.business.person.entity.VerknuepfungsStatus verknuepfungsStatus) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.person.entity.VerknuepfungsGrundlage verknuepfungsGrundlageCheckedAndAttached =  checkAndAttach(verknuepfungsGrundlage, de.ivu.elect.business.person.entity.VerknuepfungsGrundlage.class, "verknuepfungsGrundlage"); ;
		  			  de.ivu.elect.business.person.entity.VerknuepfungsStatus verknuepfungsStatusCheckedAndAttached =  checkAndAttach(verknuepfungsStatus, de.ivu.elect.business.person.entity.VerknuepfungsStatus.class, "verknuepfungsStatus"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_VERKNUEPFUNG.WahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, verknuepfungsGrundlageCheckedAndAttached)
                                        .setParameter(3, verknuepfungsStatusCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenVerknuepfung, findByWahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", verknuepfungsGrundlage:'"+verknuepfungsGrundlage+"'"
           + ", verknuepfungsStatus:'"+verknuepfungsStatus+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndVerknuepfungsGrundlageAndVerknuepfungsStatus(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT pv FROM PersonenVerknuepfung pv WHERE pv.person1.wahl=?1<br>
      * SQL: <br>
      */
     public java.util.List<PersonenVerknuepfung> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("PERSONEN_VERKNUEPFUNG.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("PersonenVerknuepfung, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.person.entity.PersonenVerknuepfungUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.person.entity.PersonenVerknuepfungUK uk,
        de.ivu.elect.business.person.entity.PersonenVerknuepfungPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.person.entity.PersonenVerknuepfung findByUK(de.ivu.elect.business.person.entity.PersonenVerknuepfungUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}